#include <errno.h>
#include <fcntl.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include "fuseactions.h"

unsigned char* tempfs;

// Map filesystem to memory
void MapFS(int fd)
{
    tempfs = mmap(NULL, FSSIZE, PROT_READ | PROT_WRITE, MAP_SHARED, fd, 0);
    if (tempfs == NULL)
    {
        perror("mmap failed");
        exit(EXIT_FAILURE);
    }
    close(fd);
    return;
}

// Unmap filesystem from memory
void UnmapFS(void)
{
    munmap(tempfs, FSSIZE);
    return;
}

// Sets defaults of a new filesystem
void FormatFS(FileSystemStruct* fs)
{
    SetFileSystemDefaults(fs);
    return;
}

// Load existing filesystem
// Depreciated Function
void LoadFS(FileSystemStruct** fs)
{
    *fs = (FileSystemStruct*) (tempfs);
    return;
}

// List path names of all used inodes
void ListFS(FileSystemStruct* fs)
{
    for (int i = 0; i < 4; i++)
        for (int j = 0; j < 32; j++)
            if ((fs->fbl.freeList[i] & (1 << j)) == (1 << j))
                printf("%s\n", fs->inodes[i*32 + j].filePath);
    return;
}

// Adds a file to the filesystem
void AddFileToFS(FileSystemStruct* fs, char* fname)
{
    struct stat statBuffer;
    ino_t inodeNumber = GetFreeInodeNumber(fs->fbl.freeList);
    strcpy(fs->inodes[inodeNumber].filePath, fname);
    stat(fname, &statBuffer);
    fs->inodes[inodeNumber].fileSize = statBuffer.st_size;
    int fd = open(fname, O_RDONLY);
    if (fd < 0)
    {
        perror(fname);
        exit(1);
    }
    read(fd, fs->inodes[inodeNumber].dataBlock.byte, sizeof(BlockStruct));
    close(fd);
}

// Remove a file from the filesystem
void RemoveFileFromFS(FileSystemStruct* fs, char* fname)
{

}

// Extract a file from the filesystem
void ExtractFileFromFS(FileSystemStruct* fs, char* fname)
{
    
}
